#include <iostream>
#include <vector>
#include <set>

using namespace std;
const int fib_size = 90;
long long answer = 0;
set<vector<int>> used;

void rec(int index, long long now, long long cn, vector<int> &count_s1, vector<long long> &s1) {
    if (index == s1.size()) {
        if (now == cn) { answer++; }
        return;
    }
    rec(index + 1, now, cn, count_s1, s1);
    for (int i = 0; i < count_s1[index]; i++) {
        now *= s1[index];
        if (now > cn){break;}
        rec(index + 1, now, cn, count_s1, s1);
    }

}

int main() {
    int t;
    cin >> t;
    vector<long long> s1(fib_size, 0);
    s1[0] = 2, s1[1] = 3;
    for (int i = 2; i < s1.size(); i++) {
        s1[i] = s1[i - 1] + s1[i - 2];
    }
    while (t--) {
        long long n, cn;
        cin >> n;
        cn = n;
        if (n == 1) { cout << 0; }
        else {
            //long long a = 1, b = 2;

            vector<int> count_s1(fib_size, 0);
            for (int i = 0; i < fib_size; i++) {
                while (n % s1[i] == 0) {
                    count_s1[i]++;
                    n /= s1[i];
                }
                n = cn;
            }

            rec(0, 1, cn, count_s1, s1);
            cout << answer << '\n';
            answer = 0;
        }
    }
    return 0;
}