#include <iostream>
#include <vector>

using namespace std;
typedef long long i64;

const i64 end1 = 1e9 + 7;

int main() {
    i64 A, n;
    cin >> n >> A;
    vector<i64> s1(A);
    for (int i = 0; i < A; i++) { cin >> s1[i]; }
    vector<vector<i64>> s2(A);
    if (s1.size() == 2 && s1[0] == 1) {
        vector<pair<i64, i64>> typ_fib(n, {0, 0});
        typ_fib[0].first = 1;
        typ_fib[0].second = 1;
        for (int j = 1; j < n; j++) {
            typ_fib[j].first = typ_fib[j - 1].first + typ_fib[j - 1].second;
            if (j >= s1[1]) { typ_fib[j].second = typ_fib[j - s1[1]].first + typ_fib[j - s1[1]].second; }
            else { typ_fib[j].second = 1; }
            typ_fib[j].first %= end1;
            typ_fib[j].second %= end1;
        }
        //for (int i =0;i<n;i++){cout << typ_fib[i].first << ' ' << typ_fib[i].second << '\n';}
        cout << (typ_fib[n - 1].first + typ_fib[n - 1].second) % end1;
    } else {
        for (int i = 0; i < A; i++) { s2[i].resize(n + 1, 0); }
        for (int i = 0; i < A; i++) {
            for (int j = 1; j <= n; j++) {
                if (i == 0) { s2[i][j] = 1; }
                else {
                    i64 k = s2[i - 1][j] + 1 + s2[i - 1][j - 1] * i;
                    if (j >= s1[i]) { k += s2[i][j - s1[i]] * i; }
                    k %= end1;
                    s2[i][j] = k;
                }
            }

        }
        cout << s2[A - 1][n];
    }
}