#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
typedef long long i64;

const i64 end1 = 1e9 + 7;
i64 answer = 0;

struct queue {
    i64 first, second;

    void init(i64 a, i64 b) {
        first = a, second = b;
        if (first > second) { swap(first, second); }
    }
};


int main() {
    int n, q;
    cin >> n >> q;
    vector<i64> s1(n);
    for (int i = 0; i < n; i++) { cin >> s1[i]; }
    vector<vector<int>> table(n);
    bool sorted_ = true;
    for (int i = 1; i < s1.size(); i++) {
        if (s1[i] < s1[i - 1]) {
            sorted_ = false;
            break;
        }
    }
    if (sorted_) {
        for (int i = 0; i < q; i++) {
            int p, k;
            cin >> p >> k;
            int ans = 0;
            if (p >= k) { ans++; }
            if (k + p - 1 <= n) { ans++; }
            cout << ans << '\n';
        }
    } else {
        for (int i = 0; i < n; i++) { table[i].resize(n, 0); }
        for (int j = 0; j < n; j++) {
            int now = j, first = j + 1, second = j - 1;
            table[0][j]++;
            for (int x = 1; x < n; x++) {
                if (first < n && second >= 0) {
                    if (s1[first] < s1[second]) {
                        now = first;
                        first++;
                    } else {
                        now = second;
                        second--;
                    }
                } else if (first < n) {
                    now = first;
                    first++;
                } else {
                    now = second;
                    second--;
                }
                table[j][now] = x;
            }
        }
        for (auto &x: table) {
            for (auto j: x) { cout << j << ' '; }
            cout << '\n';
        }
        for (int i = 0; i < q; i++) {
            int p, k;
            cin >> p >> k;
            p--;
            int ans = 0;
            cout << table[k - 1][p] << '\n';
        }
    }
}